def read_in_vfile(filename) :
    fp = open(filename,"r")
    lns = fp.readlines()
    v = map(lambda u : vector( eval("["+u.replace(" ",",").replace("\n","]")) ), lns)
    fp.close()
    return(v)

def write_out_vfile(filename,v) :
    fp = open(filename,"w")
    lns = map(lambda u : str(u).replace(",","").replace("(","").replace(")","")+"\n",v)
    fp.writelines(lns)
    fp.close()

def write_out_scenario(base,scenario,num) :
    TB = base+('%05d'%num)

    tfilen = TB+"/initial.txt"
    tlist = [scenario[1],scenario[2][0]] + [scenario[2][1][k] for k in range(0,7)]
    write_out_vfile(tfilen,tlist)
    
    tfilen = TB+"/uvals.txt"
    write_out_vfile(tfilen,scenario[5])

    tfilen = TB+"/wvals.txt"
    write_out_vfile(tfilen,scenario[3])

    tfilen = TB+"/wdefs.txt"
    tlist = [scenario[4][0]]+[scenario[4][1][k] for k in range(0,5)]
    write_out_vfile(tfilen,tlist)

    tfilen = TB+"/nvals.txt"
    write_out_vfile(tfilen,scenario[6])

    tfilen = TB+"/ndefs.txt"
    tlist = [scenario[7][0]]+[scenario[7][1][k] for k in range(0,2)]
    write_out_vfile(tfilen,tlist)

    tfilen = TB+"/measures.txt"
    write_out_vfile(tfilen,scenario[8])


def read_in_scenario(base,num) :

    TB = base+('%05d'%num)
    
    tfilen = TB+"/initial.txt"
    tvin = read_in_vfile(tfilen)
    truth_s0 = tvin.pop(0)
    est_s0 = tvin.pop(0)
    s0 = (est_s0,matrix(tvin))

    tfilen = TB+"/uvals.txt"
    uvals = read_in_vfile(tfilen)
    
    tfilen = TB+"/wvals.txt"
    wvals = read_in_vfile(tfilen)

    tfilen = TB+"/wdefs.txt"
    tvin = read_in_vfile(tfilen)
    wmean = tvin.pop(0)
    w_var = (wmean,matrix(tvin))
    
    tfilen = TB+"/nvals.txt"
    nvals = read_in_vfile(tfilen)

    tfilen = TB+"/ndefs.txt"
    tvin = read_in_vfile(tfilen)
    nmean = tvin.pop(0)
    n_var = (nmean,matrix(tvin))

    tfilen = TB+"/measures.txt"
    measures = read_in_vfile(tfilen)

    return (len(wvals),truth_s0,s0,wvals,w_var,uvals,nvals,n_var,measures)
